Content Translation feature parity checklist post VisualEditor integration
Open, HighPublic0 Story Points

Description

Integration of Content Translation (CX) and Visual Editor (VE) is supposed, at first, to change the contenteditable editing component to VE and preserve the current CX functionality—and nothing else. It is important to ensure that features already available in ContentTranslation are retained and these would specifically be:

Immediate priority: (total time estimate: 9 person-days)

  1. [ST w/ help from DC, ES] Being able to publish pages to the target wiki (there is no publish button in the interface at present) [1d] T162768
    1. Translation should be saved as translator edits (autosave) [0.5d] T176610: CX2: Integrate auto save with VE content changes
      1. [ST] Timer for auto-saving.
      2. Showing a saved in-progress translation on the dashboard (not related to VE as such, but essential part of auto-saving)
    2. Restoring a saved translation against the version of the source article on which it was initiated. The translated text must be loaded with the same content as it had when it was auto-saved. (presently it does not save or load(!!!)) [0.5d] T176843: CX2: Restore the saved translation
  2. [ST] In case that machine translation is not available, null MT so that, if the user selected “source text”, the target text must be pre-filled with the (adapted) source text [0.5d, or may be working already]
  3. [ES] Presently you can add a link to the source text, which is not correct (the source text should not be writable at all!) [0.5d]
  4. [NL&ST] template adaptation for a few important templates [5d] T162114
  5. [RK] Feed existing (server-side) adapted categories into VE [1d] T177303

New priorities:

  1. [MT/Adaptation] UI for the user to select between different MT engines / null MT
    1. [MT/Adaptation] When the user switches between different MT [Apertium/Yandex etc] options, those will preserve any changes the user made to their content. An additional option to reset to the initial content will be available when the content has been modified.
    2. [Prefilling translations] If the user selected “no automatic translation”, it must remain empty.
  2. Restoring a saved translation against a changed source article. [5d]
    1. Restoring saved translations from CX1 into CX2 [optimistically included in those 5d]
  3. [UI] Link tool to be as close to the CX1 one as feasible in terms of UX (in the third column, rather than as an inspector)]
    1. [Link UI] Red/blue-ness and href of links should be taken from the relevant wiki - LinkCache related [1d]
    2. [Link UI] If text is selected in the target column that can be linked to an existing article in the target wiki, the link tool must be shown that allows to link to it.
    3. [Link UI / Source inspector] Clicking a link in the source column must show a link card with the source article (with title and image if available). If a directly corresponding target article exists, it must be shown, too. The link card must allow adding the link to the translation.
  4. [MT/Adaptation] A warning card is shown when the user has added automatic content without editing above a defined threshold.-Includes progress calculation - depends MT switching tool
  5. Integration with abuse filter and checking that it works
  6. [Snack-sized] The “+ Add translation” placeholder must be shown in the first section on load (immediately, rather than just on hover)
  7. [UI] [Source inspector] Clicking a reference [in the source column?] must show a reference card in the sidebar. The card must have a button that adds the reference to the translation.
  8. [UI] Wire up category widget at bottom to DM, or put a VE category widget there
  9. [UI] Rest of the system to be as close to CX1 as feasible in terms of UX
  10. [Adaptation] Preserve the template editor functionality: the ability to adapt each parameter in the UI. [some weeks]

Even lower priority :-p

  1. Dictionary tool
  2. Formatting tool (bold, italic, etc) - What formatters to add - Pending on UI decisions
  3. Nicer category tool (show adaptations side-by-side)

Previously completed:

  1. [Adaptation] image adaptation [done; is the bug with block images breaking segmentation fixed already? Yes it is fixed Sweet! AFAIK]
  2. [Adaptation] reference adaptation [done, but since most refs contain templates it doesn't work in most practical cases yet, it will "magically" work when template adaptation is done]
  3. he source column must show a loading indicator.
  4. The translation column must have no content.
  5. The “+ Add translation” placeholder must be shown in other sections on hover.
  6. Source and target paragraphs remain always vertically aligned. If the user extends a paragraph in the translation by adding more content, the paragraphs below will be automatically pushed down to keep the visual alignment.
  7. Hovering over a source or target paragraph highlights in yellow the corresponding one.
  8. Link adaptation must work automatically when using automatic translation (see above).
  9. It must be possible to add a link to a non-existing (“red”) target article.
  10. Not required for the MVP, but we can consider support for adding new templates using VE's buttons and forms to the translation if it does not require extra work.
  11. Not required for the MVP, but we can consider support for editing or adding new elements using VE's buttons and forms if this doesn't require extra work.
Arrbee created this task.Nov 14 2016, 12:00 PM
Jdforrester-WMF set the point value for this task to 0.Feb 9 2017, 6:18 PM

Is this now complete?

Amire80 moved this task from Jan.-Mar. 2017 to CX2 on the ContentTranslation board.May 8 2017, 1:02 PM
Arrbee renamed this task from Minimal requirements for first phase of implementation of VisualEditor integration into Content Translation to Content Translation feature parity checklist post VisualEditor integration.Jul 13 2017, 2:48 PM
Arrbee updated the task description. (Show Details)
Pginer-WMF updated the task description. (Show Details)Jul 13 2017, 3:04 PM
Arrbee updated the task description. (Show Details)Jul 13 2017, 3:15 PM
Pginer-WMF updated the task description. (Show Details)Aug 3 2017, 7:41 AM
Amire80 updated the task description. (Show Details)Aug 28 2017, 1:49 PM
Esanders updated the task description. (Show Details)Aug 29 2017, 6:02 PM
Esanders updated the task description. (Show Details)Aug 30 2017, 7:31 PM
Deskana updated the task description. (Show Details)Sep 14 2017, 7:19 AM
Deskana added subscribers: Deskana, Catrope.

Updated task description with output of CX re-triaging meeting with @Amire80 @santhosh @Catrope @dchan @Esanders @Deskana

Deskana raised the priority of this task from Normal to High.Sep 14 2017, 7:33 AM

Presently you can add a link to the source text

I can't reproduce this. Do we know who reported it?

Presently you can add a link to the source text

I can't reproduce this. Do we know who reported it?

I don't see this issue either.

Deskana updated the task description. (Show Details)Sep 15 2017, 9:09 AM

I don't see this issue either.

I've marked it as done, then.

For now, I'm not going to move things in the first section to the "Completed" section, so we can track our progress on the specific items we identified yesterday.

Esanders updated the task description. (Show Details)Sep 15 2017, 1:53 PM
Arrbee updated the task description. (Show Details)Sep 20 2017, 8:41 AM
santhosh updated the task description. (Show Details)Mon, Sep 25, 11:35 AM
santhosh updated the task description. (Show Details)Wed, Sep 27, 9:10 AM
Amire80 updated the task description. (Show Details)Wed, Sep 27, 4:48 PM
Arrbee updated the task description. (Show Details)Thu, Sep 28, 6:32 AM
Arrbee updated the task description. (Show Details)
[ST] In case that machine translation is not available, null MT so that, if the user selected “source text”, the target text must be pre-filled with the (adapted) source text [0.5d, or may be working already]

It works already. Screenshot shows en-ml translation, with no MT client. Source get copied to target with all links, references adapted to target language.

santhosh updated the task description. (Show Details)Thu, Sep 28, 12:02 PM
Elitre awarded a token.Mon, Oct 2, 9:58 AM
Catrope updated the task description. (Show Details)Tue, Oct 3, 5:47 PM
Arrbee updated the task description. (Show Details)Thu, Oct 5, 8:12 AM
Arrbee updated the task description. (Show Details)Tue, Oct 10, 5:36 PM
Arrbee updated the task description. (Show Details)
Deskana updated the task description. (Show Details)Tue, Oct 17, 6:12 AM
Deskana updated the task description. (Show Details)Tue, Oct 17, 7:12 AM

Updated task description based on re-triaging meeting held today.

Deskana updated the task description. (Show Details)Tue, Oct 17, 5:01 PM